import sys, glob, os
from collections import defaultdict
import itertools as it
import utils
import numpy as np

def str2alnum(s):
    return "".join([ch for ch in s if ch.isalnum()])

def read_data_ielex_type(fname, iso_list = None):
    delchars = ''.join(c for c in map(chr, range(256)) if not c.isalnum())
    line_id = 0
    cogid_dict = defaultdict(lambda : defaultdict())
    cogid_count = defaultdict(list)
    langs_list, concepts_list = [], []
    f = open(fname, "r")
    f.readline()
    for line in f:
        line = line.strip()
        arr = line.split("\t")
        lang = str2alnum(arr[0])
        iso_code = arr[1]
        if iso_list is not None and iso_code not in iso_list:
            continue

        concept = str2alnum(arr[2])#.replace("/","_")
        cogid = arr[6]
        cogid = cogid.replace("-","")
        cogid = cogid.replace("?","")
        cogid_dict[concept][line_id,iso_code] = cogid
        if cogid not in cogid_count[concept]:
            cogid_count[concept].append(cogid)
        if lang not in langs_list:
            langs_list.append(lang)
        line_id += 1
    f.close()
    #print(list(cogid_dict.keys()))
    return (cogid_dict, cogid_count, iso_list)
    return (cogid_dict, cogid_count, langs_list)
    

iso_list = [x.strip() for x in open("abvd.iso.list", "r")]

for in_name in glob.iglob(sys.argv[1]+"/abvd*"):
    
    print("Processing family file ", in_name)
    cogid_dict, cogid_count, langs_list = read_data_ielex_type(in_name, iso_list = iso_list)
    if len(list(cogid_dict.keys())) < 90: 
        print("!!!!Has less than 100 concepts!!!!")
        continue
    
    bin_mat = []
    sorted_list = sorted(cogid_count.items(), key=lambda cogid_count: len(cogid_count[1]))

    out_dirname = in_name.split("/")[1].split(".")[0]

    if not os.path.exists(out_dirname):
        os.makedirs(out_dirname)
    else:
        print("The path ",out_dirname, " exists")
        continue
    
    concepts_writer = open(out_dirname+".concepts.list","w")

    for concept, val in sorted_list:
        print(concept,str(len(val)), sep="\t",file=concepts_writer)
        bin_mat += utils.dict2binarynexus(cogid_dict[concept], langs_list)
        nchar, nlangs = np.array(bin_mat).shape
        outname = out_dirname+"/"+concept
        print(concept, nlangs, nchar)
        fw = open(outname+".nex","w")
        fw.write("begin data;"+"\n")
        fw.write("   dimensions ntax="+str(nlangs)+" nchar="+str(nchar)+";\nformat datatype=restriction interleave=no missing= ? gap=-;\nmatrix\n")

        for row, lang in zip(np.array(bin_mat).T, langs_list):
            #print(row,len(row), "\n")
            rowx = "".join([str(x) for x in row])
            fw.write(lang+"\t"+rowx.replace("2","?")+"\n")
        fw.write(";\nend;")
        fw.close()
    concepts_writer.close()


